<?php
$themeConfig = $this->config->get('themecontrol');

$DISPLAY_MODE = 'grid';
if( isset($themeConfig['cateogry_display_mode']) ){
	$DISPLAY_MODE = $themeConfig['cateogry_display_mode'];
}
$MAX_ITEM_ROW = 4; 
if( isset($themeConfig['cateogry_product_row']) && $themeConfig['cateogry_product_row'] ){
	$MAX_ITEM_ROW = $themeConfig['cateogry_product_row'];
}
$categoryPzoom = isset($themeConfig['category_pzoom']) ? $themeConfig['category_pzoom']:0; 
?>


<div class="box pav-featured">
	<h3 class="box-heading"><span><?php echo $heading_title; ?></span></h3>	
	<div class="product-grid">
		<?php
		$cols = $MAX_ITEM_ROW ;
		$span = floor(12/$cols);
		foreach ($products as $i => $product) { ?>
		<?php if( $i++%$cols == 0 ) { ?>
		<div class="row-fluid">
		<?php } ?>					
			<div class="pav-span<?php echo $span;?>">						
				<?php if( $product['special'] ) {   ?>
					<span class="product-label-special label"><?php echo $this->language->get( 'text_sale' ); ?></span>
				<?php } ?>
					
				<div class="product_block">
					<div class="pav-product-grid clearfix">
						<?php if ($product['thumb']) { ?>
							<div class="image product-top">
								<a href="<?php echo $product['href']; ?>"><img src="<?php echo $product['thumb']; ?>" title="<?php echo $product['name']; ?>" alt="<?php echo $product['name']; ?>" /></a>
								<?php if( $categoryPzoom ) { 
									$zimage = str_replace( "cache/","", preg_replace("#-\d+x\d+#", "",  $product['thumb'] ));  ?>
									<a href="<?php echo $zimage;?>" class="colorbox product-zoom" rel="colorbox" title="<?php echo $product['name']; ?>">
										<span class="icon-zoom-in"></span>
									</a>
								<?php } ?>
							</div>
						<?php } ?>
					
						<div class="product-bottom">
							<h3 class="name"><a href="<?php echo $product['href']; ?>"><?php echo $product['name']; ?></a></h3>				
							
							<?php if ($product['price']) { ?>
							<div class="price">
								<?php if (!$product['special']) { ?>
								<?php echo $product['price']; ?>
								<?php } else { ?>
								<span class="price-old"><?php echo $product['price']; ?></span> <span class="price-new"><?php echo $product['special']; ?></span>
								<?php } ?>								
							</div>
							<?php } ?>														
							
							<?php if ($product['rating']) { ?>
							<div class="rating">
								<img src="catalog/view/theme/pav_metro/image/stars-<?php echo $product['rating']; ?>.png" alt="<?php echo $product['reviews']; ?>" />
							</div>
							<?php } ?>								

							<div class="pav-action clearfix">
								<div class="cart">
									<input type="button" value="<?php echo $button_cart; ?>" onclick="addToCart('<?php echo $product['product_id']; ?>');" class="button" />
								</div>
								<div class="wishlist">
									<a class="button" onclick="addToWishList('<?php echo $product['product_id']; ?>');" title="<?php echo $this->language->get("button_wishlist"); ?>" ><?php echo $this->language->get("button_wishlist"); ?></a>
								</div>
								<div class="compare">  
									<a class="button" onclick="addToCompare('<?php echo $product['product_id']; ?>');" title="<?php echo $this->language->get("button_compare"); ?>" ><?php echo $this->language->get("button_compare"); ?></a>            
								</div>
							</div>							
						</div>	
					</div>		
				</div>
			</div>
			
			<?php if( $i%$cols == 0 || $i==count($products) ) { ?>
			</div> <!-- End row-fluid -->
			<?php } ?>		
		
			<?php } ?>  <!-- End loop foreach --> 			
	</div>
	
	<?php if( $categoryPzoom ) {  ?>
	<script type="text/javascript">
	<!--
	$(document).ready(function() {
		$('.colorbox').colorbox({
			overlayClose: true,
			opacity: 0.5,
			rel: false,
			onLoad:function(){
				$("#cboxNext").remove(0);
				$("#cboxPrevious").remove(0);
				$("#cboxCurrent").remove(0);
			}
		});
	});
	//-->
	</script>
	<?php } ?>	
	
</div>
